require "paybase/client/connection"

require "paybase/client/accounts"
require "paybase/client/banks"
# require "paybase/client/cards"
# require "paybase/client/documents"
require "paybase/client/customers"
# require "paybase/client/guests"
# require "paybase/client/statements"
require "paybase/client/transactions"

module Paybase
  class Client
    include HTTParty
    include Paybase::Client::Connection
    include Paybase::Client::Accounts
    include Paybase::Client::Banks
    # include Paybase::Client::Cards
    # include Paybase::Client::Documents
    include Paybase::Client::Customers
    # include Paybase::Client::Guests
    # include Paybase::Client::Statements
    include Paybase::Client::Transactions

    base_uri "https://api-json.sandbox.paybase.io/v1"
    format :json

    def initialize(access_token = nil)
      access_token ||= ENV["PAYBASE_ACCESS_TOKEN"]
      self.class.default_options.merge!(headers: { 'Content-Type' => 'application/json', 'X-Token' => access_token })
    end

  end
end
